package threadexamples.producerconsumer;

import org.slf4j.LoggerFactory;

import java.util.concurrent.*;

public class App {
    public static void main(String[] args) {
        BlockingQueue<Item> itemQueue = new LinkedBlockingQueue<>(5);
        ExecutorService executorService = Executors.newFixedThreadPool(5);

        for (int i = 0; i < 2; i++) {
            final Producer producer = new Producer("Producer_" + i, itemQueue);
            executorService.submit(() -> {
                while (true) {
                    producer.produce();
                }
            });
        }

        for (int i = 0; i < 3; i++) {
            final Consumer consumer = new Consumer("Consumer_" + i, itemQueue);
            executorService.submit(() -> {
                while (true) {
                    consumer.consume();
                }
            });
        }

        executorService.shutdown();

        try {
            executorService.awaitTermination(10, TimeUnit.SECONDS);
            executorService.shutdownNow();
        } catch (InterruptedException e) {
            LoggerFactory.getLogger(App.class).error("Error waiting for ExecutorService shutdown");
        }

    }
}
