package ovh.gasser.di;

import java.util.Arrays;
import java.util.Map;

public interface InjectionUtils {
    static void populateConstants(Class<?> clazz, Map<?, ?> values) {
        Arrays.stream(clazz.getDeclaredFields())
                .filter(field -> field.isAnnotationPresent(InjectConstant.class))
                .forEach(field -> {
                    try {
                        field.set(null, values.get(field.getName()));
                    } catch (IllegalAccessException e) {
                        throw new RuntimeException("Unable to setup constant for field " + field.getName(), e);
                    }
                });
    }
}
