package fr.gasser.gui.test;

import javax.swing.*;
import java.awt.*;

public class Main extends JFrame {

    private static final String TEXT = "你好，世界";
    private final Model model;
    private final View view;

    private Main() {
        super("Demo");
        setDefaultCloseOperation(EXIT_ON_CLOSE);

        // Initialize model
        model = new Model(
                new Font("Fira Sans", Font.PLAIN, 50),
                new Point(50, 50),
                Color.RED, TEXT
        );

        view = new View(model);
        getContentPane().add(view);

        setJMenuBar(createMenuBar());

        pack();
        setVisible(true);
    }

    private JMenuBar createMenuBar() {
        final JMenuBar menuBar = new JMenuBar();
        final JButton bold = new JButton("B");
        bold.addActionListener(evt -> {
            model.setBold(!model.getFont().isBold());
            view.repaint();
        });
        menuBar.add(bold);

        final JButton italic = new JButton("I");
        italic.addActionListener(evt -> {
            model.setItalic(!model.getFont().isItalic());
            view.repaint();
        });
        menuBar.add(italic);

        final JButton antiAlias = new JButton("AA");
        antiAlias.addActionListener(evt -> {
            model.setAntialias(!model.isAntialiased());
            view.repaint();
        });
        menuBar.add(antiAlias);

        return menuBar;
    }

    public static void main(String[] args) {
        EventQueue.invokeLater(Main::new);
    }
}
