package annotations.jsonserializer;

import java.util.Set;
import java.util.stream.Collectors;

class JsonSerializer {

    private final SerializableFieldExtractor extractor;

    JsonSerializer(SerializableFieldExtractor extractor) {
        this.extractor = extractor;
    }

    String serializeToString(Object o) {
        return toJsonString(serialize(o));
    }

    Set<SerializableField> serialize(Object o) {
        return extractor.getSerializableFields(o);
    }

    String toJsonString(Set<SerializableField> jsonElements) {
        String elementsString = jsonElements.stream()
                .map(entry -> "\"" + entry.getName() + "\":\"" + entry.getValue() + "\"")
                .collect(Collectors.joining(","));
        return "{" + elementsString + "}";
    }
}
