package messagebroker;

import java.io.OutputStream;

public class MessageHandlerContext {
    private final MessageBroker broker;
    private OutputStream outputStream;

    MessageHandlerContext(MessageBroker broker) {
        this(broker, null);
    }

    private MessageHandlerContext(MessageBroker broker, OutputStream outputStream) {
        this.broker = broker;
        this.outputStream = outputStream;
    }

    public MessageBroker getBroker() {
        return broker;
    }

    public OutputStream getOutputStream() {
        return outputStream;
    }

    public void setOutputStream(OutputStream outputStream) {
        this.outputStream = outputStream;
    }
}
