package fr.gasser.daoexample;

import fr.gasser.daoexample.dao.Dao;
import fr.gasser.daoexample.dao.DaoAbstractFactory;
import fr.gasser.daoexample.model.Discipline;
import fr.gasser.daoexample.model.Student;
import fr.gasser.daoexample.model.Teacher;

public class FirstTest {
    public static void main(String[] args) {
        DaoAbstractFactory df = DaoAbstractFactory.createFactory();
        Dao<Student> studentDao = df.createStudentDao();
        for (int i = 0; i < 3; i++) {
            Student student = studentDao.find(i);
            System.out.println("Student #" + student.getId() + "  - " + student.getName() + " " + student.getSurname());
        }

        System.out.println("\n********************************\n");
        Dao<Teacher> teacherDao = df.createTeacherDao();
        for (int i = 0; i < 3; i++) {
            Teacher teacher = teacherDao.find(i);
            System.out.println("Teacher #" + teacher.getId() + "  - " + teacher.getName() + " " + teacher.getSurname());
        }

        System.out.println("\n********************************\n");
        Dao<Discipline> disciplineDao = df.createDisciplineDao();
        for (int i = 0; i < 3; i++) {
            Discipline discipline = disciplineDao.find(i);
            System.out.println("Discipline #" + discipline.getId() + "  - " + discipline.getName());
        }

    }

}
