package fr.gasser.daoexample.dao;

import fr.gasser.daoexample.dao.dummy.DaoFactory;
import fr.gasser.daoexample.dao.dummy.FactoryType;
import fr.gasser.daoexample.dao.sqlite.SqliteDaoFactory;
import fr.gasser.daoexample.model.Discipline;
import fr.gasser.daoexample.model.Student;
import fr.gasser.daoexample.model.Teacher;

public interface DaoAbstractFactory {

    static DaoAbstractFactory createFactory(FactoryType type) {
        switch (type) {
            case XmlDaoFactory:
                return new XmlDaoFactory();
            case SqliteDaoFactory:
                return new SqliteDaoFactory();
            default:
            case DaoFactory:
                return new DaoFactory();
        }
    }

    static DaoAbstractFactory createFactory() {
        return createFactory(FactoryType.DaoFactory);
    }

    Dao<Student> createStudentDao();

    Dao<Teacher> createTeacherDao();

    Dao<Discipline> createDisciplineDao();

}
