package fr.gasser.daoexample.dao.dummy;

import fr.gasser.daoexample.dao.Dao;
import fr.gasser.daoexample.dao.DaoAbstractFactory;
import fr.gasser.daoexample.model.Discipline;
import fr.gasser.daoexample.model.Student;
import fr.gasser.daoexample.model.Teacher;

public class DaoFactory implements DaoAbstractFactory {

    @Override
    public Dao<Student> createStudentDao() {
        return new StudentDao();
    }

    @Override
    public Dao<Teacher> createTeacherDao() {
        return new TeacherDao();
    }

    @Override
    public Dao<Discipline> createDisciplineDao() {
        return new DisciplineDao();
    }
}
