package fr.gasser.daoexample.dao.dummy;

import fr.gasser.daoexample.dao.Dao;
import fr.gasser.daoexample.model.Discipline;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

public class DisciplineDao implements Dao<Discipline> {

    // Emulate discipline table
    private final static List<Discipline> DISCIPLINES = new ArrayList<>(Arrays.asList(
            new Discipline(0, "Azerty"),
            new Discipline(1, "Foo"),
            new Discipline(2, "Qsdf")
    ));

    @Override
    public boolean create(Discipline obj) {
        return false;
    }

    @Override
    public Discipline find(int id) {
        return DISCIPLINES.get(id);
    }

    @Override
    public List<Discipline> findAll() {
        return DISCIPLINES;
    }

    @Override
    public boolean update(Discipline obj) {
        if (!containsId(obj.getId())) return false;
        DISCIPLINES.set(obj.getId(), obj);
        return true;
    }

    @Override
    public boolean delete(Discipline obj) {
        return DISCIPLINES.remove(obj);
    }

    private boolean containsId(int id) {
        return DISCIPLINES.stream().anyMatch(d -> id == d.getId());
    }
}
