package fr.gasser.daoexample.dao.dummy;

import fr.gasser.daoexample.dao.Dao;
import fr.gasser.daoexample.model.Teacher;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

public class TeacherDao implements Dao<Teacher> {

    // Emulate teacher table
    private final static List<Teacher> teachers = new ArrayList<>(Arrays.asList(
            new Teacher(0, "Uiop", "Jklm"),
            new Teacher(1, "Lorem", "Ipsum"),
            new Teacher(2, "Sit", "Amet"))
    );

    @Override
    public boolean create(Teacher obj) {
        return teachers.add(obj);
    }

    @Override
    public Teacher find(int id) {
        return teachers.get(id);
    }

    @Override
    public List<Teacher> findAll() {
        return teachers;
    }

    @Override
    public boolean update(Teacher obj) {
        if (!containsId(obj.getId())) return false;
        teachers.set(obj.getId(), obj);
        return true;
    }

    @Override
    public boolean delete(Teacher obj) {
        return teachers.remove(obj);
    }

    private boolean containsId(int id) {
        return teachers.stream().anyMatch(t -> id == t.getId());
    }

}
