package fr.gasser.daoexample.dao.sqlite;

import fr.gasser.daoexample.dao.Dao;
import fr.gasser.daoexample.dao.DaoAbstractFactory;
import fr.gasser.daoexample.model.Discipline;
import fr.gasser.daoexample.model.Student;
import fr.gasser.daoexample.model.Teacher;
import fr.gasser.daoexample.dao.connection.ConnectionWrapper;
import fr.gasser.daoexample.dao.connection.SQLiteConnectionWrapper;

public class SqliteDaoFactory implements DaoAbstractFactory {

    private static final ConnectionWrapper conn = new SQLiteConnectionWrapper();

    @Override
    public Dao<Student> createStudentDao() {
        return new StudentSQLiteDao(conn);
    }

    @Override
    public Dao<Teacher> createTeacherDao() {
        return null;
    }

    @Override
    public Dao<Discipline> createDisciplineDao() {
        return null;
    }
}
