package fr.gasser.daoexample.model;

import java.util.HashSet;
import java.util.Set;

public class Discipline extends Entity {

    private String name;
    private Set<Teacher> teachers;
    private Set<Student> students;

    public Discipline(int id, String name) {
        super(id);
        this.name = name;
        this.teachers = new HashSet<>();
        this.students = new HashSet<>();
    }

    public Discipline(int id) {
        super(id);
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public boolean addTeacher(Teacher teacher) {
        return teachers.add(teacher);
    }

    public boolean removeTeacher(Teacher t) {
        return teachers.remove(t);
    }

    public boolean addStudent(Student student) {
        return students.add(student);
    }

    public boolean removeStudent(Student s) {
        return students.remove(s);
    }
}
