package fr.gasser.daoexample.model;

import java.util.HashSet;
import java.util.Set;

public class Teacher extends Entity {

    private String name;
    private String surname;
    private Set<Discipline> disciplines;

    public Teacher(int id, String name, String surname) {
        super(id);
        this.name = name;
        this.surname = surname;
        this.disciplines = new HashSet<>();
    }

    public Teacher(int id) {
        super(id);
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public String getSurname() {
        return surname;
    }

    public void setSurname(String surname) {
        this.surname = surname;
    }

    public Set<Discipline> getDisciplines() {
        return disciplines;
    }

    public boolean addDiscipline(Discipline discipline) {
        return disciplines.add(discipline);
    }

    public boolean removeDiscipline(Discipline discipline) {
        return disciplines.remove(discipline);
    }

}
