package fr.gasser.reflection;

import java.lang.reflect.ParameterizedType;

/**
 * Shows how to access generic type parameter type at runtime.
 */
public abstract class GenericClass<T> {

    private Class<T> clazz;

    @SuppressWarnings("unchecked")
    private GenericClass() {
        ParameterizedType genericSuperclass = (ParameterizedType) getClass().getGenericSuperclass();
        this.clazz = (Class<T>) genericSuperclass.getActualTypeArguments()[0];
    }

    Class<T> getClazz() {
        return clazz;
    }

    public static void main(String[] args) {
        System.out.println(new GenericClass<Long>() {}.getClazz());
        System.out.println(new GenericClass<Integer>() {}.getClazz());
    }
}
