package ovh.gasser.spi;

import ovh.gasser.spi.commands.Command;

import java.util.Optional;
import java.util.ServiceLoader;
import java.util.stream.Stream;

public class CommandProvider {
    private static CommandProvider instance = new CommandProvider();

    private final ServiceLoader<Command> loader;

    private CommandProvider() {
        loader = ServiceLoader.load(Command.class);
    }

    public static CommandProvider getInstance() {
        return instance;
    }

    public Stream<Command> getCommands() {
        return loader.stream().map(ServiceLoader.Provider::get);
    }

    public Optional<Command> getCommand(String commandId) {
        return loader.stream()
                .filter(commandProvider -> commandProvider.get().getId().equalsIgnoreCase(commandId))
                .findFirst()
                .map(ServiceLoader.Provider::get);
    }
}
